#ifndef LIB_LIGHT_H
#define LIB_LIGHT_H

#include "math/vec.h"

//bitflags for light setup - 
enum {
	LIGHT_POS = 1,
	LIGHT_AMB = 2,
	LIGHT_DIFF = 4,
	LIGHT_SPEC = 8,
	LIGHT_ATTN = 16,
};

class Light {
public:
	vec4f		pos;
	vec4f		amb;
	vec4f		diff;
	vec4f		spec;
	vec3f		attn;

	//todo: vec3f spotDir; float spotExp; float spotCutoff;

	Light() {
		//default attenuation coefficients:
		attn = vec3f(1, 0.1f, 0);
	}

	void setup(int index, int flags = -1);

	/**
	 * associates the light class with the specified index, and enables it
	 */
	static void enable(int index);

	/**
	 * disables the specified light index
	 */
	static void disable(int index);
};

#endif
