#include "defs/defs.h"
#include "lib/springchar.h"

struct spring_char_vertex_s {
	float x,y,z;
	int bodies;
} spring_char_vertex[] = {
	//tip
	{8.5,	11,		0,		bitflag(2)},			//0		////0
	//right outer arm
	{8.0,	11.5,	0,		bitflag(2)},			//1
	{8.0,	11,		-.5,	bitflag(2)},
	{8.0,	10.5,	0,		bitflag(2)},			//2
	{8.0,	11,		0.5,	bitflag(2)},
	{6.0,	11.5,	0,		bitflag(2)},			//1
	{6.0,	11,		-.5,	bitflag(2)},
	{6.0,	10.5,	0,		bitflag(2)},			//2
	{6.0,	11,		0.5,	bitflag(2)},
	//tip
	{5.5,	11,		0,		bitflag(2)|bitflag(3)},	//3		////9
	//right inner arm
	{5.0,	11.5,	0,		bitflag(3)},			//4
	{5.0,	11,		-.5,	bitflag(3)},
	{5.0,	10.5,	0,		bitflag(3)},			//5
	{5.0,	11,		0.5,	bitflag(3)},
	{3.0,	11.5,	0,		bitflag(3)},			//4
	{3.0,	11,		-.5,	bitflag(3)},
	{3.0,	10.5,	0,		bitflag(3)},			//5
	{3.0,	11,		0.5,	bitflag(3)},
	//tip
	{2.5,	11,		0,		bitflag(1)|bitflag(3)},	//6		////18
	//torso
	{1.5,	11,		1,		bitflag(1)},
	{1.5,	11,		-1,		bitflag(1)},
	{0.5,	8,		-1,		bitflag(1)},
	{0.5,	8,		1,		bitflag(1)},
	{0.5,	7,		0,		bitflag(1)|bitflag(6)},	//8
	//hips
	{0.5,	6,		-1,		bitflag(6)},
	{0.5,	6,		1,		bitflag(6)},
	//tip
	{1,		6,		0,		bitflag(6)|bitflag(7)},	//9		////26
	//right upper leg
	{2,		5,		0,		bitflag(7)},			//10
	{1.5,	5,		0.5,	bitflag(7)},
	{1,		5,		0,		bitflag(7)},			//11
	{1.5,	5,		-.5,	bitflag(7)},
	{2,		1,		0,		bitflag(7)},			//10
	{1.5,	1,		0.5,	bitflag(7)},
	{1,		1,		0,		bitflag(7)},			//11
	{1.5,	1,		-.5,	bitflag(7)},
	//tip
	{1.5,	0,		0,		bitflag(7)|bitflag(8)},	//12	////35
	//right lower leg
	{2,		-1,		0,		bitflag(8)},			//13
	{1.5,	-1,		0.5,	bitflag(8)},
	{1,		-1,		0,		bitflag(8)},			//14
	{1.5,	-1,		-.5,	bitflag(8)},
	{2,		-5,		0,		bitflag(8)},			//13
	{1.5,	-5,		0.5,	bitflag(8)},
	{1,		-5,		0,		bitflag(8)},			//14
	{1.5,	-5,		-.5,	bitflag(8)},
	//tip
	{1.5,	-6,		0,		bitflag(8)},			//15
	//head
	{0,		12,		0,		bitflag(0)|bitflag(1)},	//16	//45
	{0,		13,		1,		bitflag(0)},
	{0,		13,		-1,		bitflag(0)},
	{1.5,	14,		1,		bitflag(0)},			//7
	{1.5,	14,		-1,		bitflag(0)},
	{-1.5,	14,		1,		bitflag(0)},			//25
	{-1.5,	14,		-1,		bitflag(0)},
	//tip
	{-1.5,	-6,		0,		bitflag(10)},			//17	//52
	//left lower leg
	{-1,	-5,		0,		bitflag(10)},			//18
	{-1.5,	-5,		-.5,	bitflag(10)},
	{-2,	-5,		0,		bitflag(10)},			//19
	{-1.5,	-5,		0.5,	bitflag(10)},
	{-1,	-1,		0,		bitflag(10)},			//18
	{-1.5,	-1,		-.5,	bitflag(10)},
	{-2,	-1,		0,		bitflag(10)},			//19
	{-1.5,	-1,		0.5,	bitflag(10)},
	//tip
	{-1.5,	0,		0,		bitflag(9)|bitflag(10)},//20	//61
	//left upper leg
	{-1,	1,		0,		bitflag(9)},			//21
	{-1.5,	1,		-.5,	bitflag(9)},
	{-2,	1,		0,		bitflag(9)},			//22
	{-1.5,	1,		0.5,	bitflag(9)},
	{-1,	5,		0,		bitflag(9)},			//21
	{-1.5,	5,		-.5,	bitflag(9)},
	{-2,	5,		0,		bitflag(9)},			//22
	{-1.5,	5,		0.5,	bitflag(9)},
	//tip
	{-1,	6,		0,		bitflag(6)|bitflag(9)},	//23
	{-0.5,	6,		1,		bitflag(6)},
	{-0.5,	6,		-1,		bitflag(6)},
	{-0.5,	7,		0,		bitflag(1)|bitflag(6)},	//24
	{-0.5,	8,		1,		bitflag(1)},
	{-0.5,	8,		-1,		bitflag(1)},
	{-1.5,	11,		-1,		bitflag(1)},
	{-1.5,	11,		1,		bitflag(1)},
	//tip
	{-2.5,	11,		0,		bitflag(1)|bitflag(4)},	//26	////78
	//left inner arm
	{-3.0,	10.5,	0,		bitflag(4)},			//27
	{-3.0,	11,		0.5,	bitflag(4)},
	{-3.0,	11.5,	0,		bitflag(4)},			//28
	{-3.0,	11,		-.5,	bitflag(4)},
	{-5.0,	10.5,	0,		bitflag(4)},			//27
	{-5.0,	11,		0.5,	bitflag(4)},
	{-5.0,	11.5,	0,		bitflag(4)},			//28
	{-5.0,	11,		-.5,	bitflag(4)},
	//tip
	{-5.5,	11,		0,		bitflag(4)|bitflag(5)},	//29	//87
	//left outer arm
	{-6.0,	10.5,	0,		bitflag(5)},			//30
	{-6.0,	11,		0.5,	bitflag(5)},
	{-6.0,	11.5,	0,		bitflag(5)},			//31
	{-6.0,	11,		-.5,	bitflag(5)},
	{-8.0,	10.5,	0,		bitflag(5)},			//30
	{-8.0,	11,		0.5,	bitflag(5)},
	{-8.0,	11.5,	0,		bitflag(5)},			//31
	{-8.0,	11,		-.5,	bitflag(5)},
	{-8.5,	11,		0,		bitflag(5)},			//32
};

#define SPRING_CHAR_ARM_AT(x)	\
	x+2,x+1,x+0,\
	x+3,x+2,x+0,\
	x+4,x+3,x+0,\
	x+1,x+4,x+0,\
	x+6,x+1,x+2,\
	x+1,x+6,x+5,\
	x+7,x+2,x+3,\
	x+2,x+7,x+6,\
	x+8,x+3,x+4,\
	x+3,x+8,x+7,\
	x+5,x+4,x+1,\
	x+4,x+5,x+8,\
	x+9,x+5,x+6,\
	x+9,x+6,x+7,\
	x+9,x+7,x+8,\
	x+9,x+8,x+5

#define SPRING_CHAR_HEAD_AT(x)	\
	x+0,x+3,x+1,\
	x+0,x+4,x+3,\
	x+0,x+2,x+4,\
	x+0,x+6,x+2,\
	x+0,x+5,x+6,\
	x+0,x+1,x+5,\
	x+1,x+3,x+5,\
	x+2,x+6,x+4,\
	x+3,x+4,x+6,\
	x+6,x+5,x+3

static int springCharTris[] = {
	SPRING_CHAR_ARM_AT(0),		//right outer arm
	SPRING_CHAR_ARM_AT(9),		//right inner arm
	SPRING_CHAR_ARM_AT(26),		//right upper leg
	SPRING_CHAR_ARM_AT(35),		//right lower leg
	SPRING_CHAR_ARM_AT(52),		//left lower leg
	SPRING_CHAR_ARM_AT(61),		//left upper leg
	SPRING_CHAR_ARM_AT(78),		//left inner arm
	SPRING_CHAR_ARM_AT(87),		//left outer arm
	SPRING_CHAR_HEAD_AT(45),	//head
#define FLIPTRI(x,y,z)	x,z,y
	//hips
	FLIPTRI(23,24,26),	//right side
	FLIPTRI(23,26,25),
	FLIPTRI(23,25,71),	//back
	FLIPTRI(71,73,23),
	FLIPTRI(73,71,70),	//left side
	FLIPTRI(73,70,72),
	FLIPTRI(73,72,24),	//front
	FLIPTRI(24,23,73),
	24,26,25,	//base
	24,25,71,
	71,72,24,
	71,70,72,
	//torso
	FLIPTRI(45,20,18),	//top
	FLIPTRI(45,18,19),
	FLIPTRI(45,19,77),
	FLIPTRI(45,77,78),
	FLIPTRI(45,78,76),
	FLIPTRI(45,76,20),
	23,20,18,	//right side
	23,18,19,
	23,19,22,	//back
	23,22,73,
	FLIPTRI(22,73,74),
	73,74,77,
	FLIPTRI(19,22,74),
	FLIPTRI(74,77,19),
	73,77,78,	//left side
	73,78,76,
	23,21,20,	//front
	FLIPTRI(73,75,76),
	23,73,75,
	75,21,23,
	20,21,75,
	75,76,20,
};

bool SpringChar::init(ParSystem *parSys, SpringSystem *springSys) {
	if (!SpringObj::init(parSys, springSys)) return false;

	if (!tex.load2D("bone.bmp")) {
		printf("failed to load the spring char texture\n");
		return false;
	}

//	tex.setFilter(GL_NEAREST, GL_NEAREST);	//disable bilinear magnification

	//create

	for (int i = 0; i < numberof(spring_char_vertex); i++) {
		Particle *p = parSys->createParticle();
		if (p == NULL) {
			printf("couldnt alloc enough particles for the spring char\n");
			return false;
		}
		vertex.push_back(p);
		for (int j = i-1; j >= 0; j--) {
			//if the two vertices <i,j> belong to any of the same bodies
			//then create a spring between them
			if (spring_char_vertex[i].bodies & spring_char_vertex[j].bodies) {

				int k = springSys->createSpring();
				if (k == -1) {
					printf("couldnt alloc enough springs for the spring char\n");
					return false;
				}

				spring.push_back(k);
			}
		}
	}

	resetShape();

	return true;
}

void SpringChar::clear() {
	SpringObj::clear();
	skyTexCubemap = NULL;
}


void SpringChar::resetShape() {
	int k = 0;
	for (int i = 0; i < numberof(spring_char_vertex); i++) {
		Particle *p = vertex[i];

		p->x.set(spring_char_vertex[i].x, spring_char_vertex[i].y, spring_char_vertex[i].z);
		p->v.set(0,0,0);
		p->clearForce();
		p->massInv = 1.f;


		for (int j = i-1; j >= 0; j--) {
			//if the two vertices <i,j> belong to any of the same bodies
			//then create a spring between them
			if (spring_char_vertex[i].bodies & spring_char_vertex[j].bodies) {

				Particle *p2 = vertex[j];

				Spring &s = springSys->spring[spring[k]]; k++;
				s.ks = 700.f;
				s.kd = 10.f;
				s.par[0] = p;
				s.par[1] = p2;
			}
		}
	}

	resetSpringLengths();
}

void SpringChar::render(const View *view) {

	glPushAttrib(GL_ENABLE_BIT);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0, GL_POSITION, vec4f(0,0,0,1));
	glEnable(GL_CULL_FACE);

	tex.bind();

	glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR);
	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);

	bool applyCubeMap = skyTexCubemap &&					//if we have a sky texture
						found_GL_ARB_multitexture &&		//and we have multitexturing
						found_GL_ARB_texture_cube_map;		//and cube mapping

	if (applyCubeMap) {
		//then apply a second coat =)
		glActiveTextureARB(GL_TEXTURE1_ARB);

		//init texture environment
		glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_ADD);

		//init cubemap reflection texture matrix
		glMatrixMode(GL_TEXTURE);
		glPushMatrix();
		//assume identity is already in the texmat
		//correct from GL space to our space
		view->correctAngleInverse();
		//do a cam inverse rotation
		view->rotateInverse();
		//correct into skymap space
		glRotatef(-90, 1, 0, 0);//correct for skytex

		glMatrixMode(GL_MODELVIEW);

		//init cube mapping
		skyTexCubemap->bind();

		//init cubemap texcoord generators
		glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP_ARB);
		glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP_ARB);
		glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP_ARB);

		//enable texcoords
		glEnable(GL_TEXTURE_GEN_S);
		glEnable(GL_TEXTURE_GEN_T);
		glEnable(GL_TEXTURE_GEN_R);
	}
	
	glColor3f(1,1,1);
	glBegin(GL_TRIANGLES);

	//first - clear normal (use the RK4 tmpF[0] variable for storing normals)
	int *v;
	for (v = springCharTris; v < endof(springCharTris); v++) {
		vertex[*v]->tmpF[0].set(0,0,0);
	}

	//second - accum normals
	for (v = springCharTris; v < endof(springCharTris); v+=3) {
		Particle *p[3];
		int i;
		for (i = 0; i < 3; i++) {
			p[i] = vertex[v[i]];
		}
		vec3f n = vec3unit(cross(p[2]->x - p[0]->x, p[1]->x - p[0]->x));
		for (i = 0; i < 3; i++) {
			p[i]->tmpF[0] += n;
		}
	}

	//third - normalize.  do this to prevent flickering lit vertices with near-zero normals (which occur using GL_NORMALIZE)
	for (v = springCharTris; v < endof(springCharTris); v++) {
		Particle *p = vertex[*v];
		float ln = dot(p->tmpF[0], p->tmpF[0]);
		if (ln < 0.000001f) {
			p->tmpF[0].set(1,0,0);
		} else {
			p->tmpF[0] *= 1.f / sqrt(ln);
		}
	}

	for (v = springCharTris; v < endof(springCharTris); v++) {
		const Particle *a = vertex[*v];
		glNormal3fv(a->tmpF[0] );
		glVertex3fv(a->x);
	}
	glEnd();

	if (applyCubeMap) {
		//disable texcoords
		glDisable(GL_TEXTURE_GEN_S);
		glDisable(GL_TEXTURE_GEN_T);
		glDisable(GL_TEXTURE_GEN_R);

		//disable cube mapping
		Texture::unbind();

		//disable cubemap reflection texture matrix
		glMatrixMode(GL_TEXTURE);
		glPopMatrix();
		glMatrixMode(GL_MODELVIEW);

		//disable texture environment
		glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

		//disable second coat =)
		glActiveTextureARB(GL_TEXTURE0_ARB);
	}

	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);
	glPopAttrib();
}


void SpringChar::updateDamageSum() {
	damageSum = 0;
	for (int i = 0; i < (int)vertex.size(); i++) {
		damageSum += vertex[i]->getDamage();
	}
}